<?php
 /*
 Plugin Name: FlowGallery
 Plugin URI: http://www.klemmkeil.de/flowgallery-wordpress-plugin/
 Description: A plugin that creates a gallery from a given directory in a sexy flow layout.
 Author: Rainer Mohr
 Version: 1.2
 Author URI: http://www.klemmkeil.de
 */
 
include(dirname(__FILE__).'/options.php');


function flowgallery_settings_link($links) { 
  $settings_link = '<a href="options-general.php?page=flowgallery-options.php">Settings</a>'; 
  array_unshift($links, $settings_link); 
  return $links; 
}

function add_this_script_footer(){ 

echo "<script type='text/javascript'>
		jQuery(document).ready(function() {	
			
		var container = jQuery('.photogrid');	
		container.masonry({		
			itemSelector: '.item'
		});		
	
		".(get_option('flowgallery_use_fancybox', "1") == 1 ?			
			"jQuery(\"a.fancybox\").fancybox({
			'titlePosition': 'inside',
			'overlayOpacity': '0.9',
			'transitionIn': 'elastic',
			'transitionOut': 'elastic'
		});
		" : "")."			
		 });
	</script>
	";

} 
add_action('wp_footer', 'add_this_script_footer'); 

wp_enqueue_script("jquery");

if (get_option('flowgallery_use_wp_masonry', "1") == 1)
{
	wp_enqueue_script('jquery-masonry');
}
else
{
	wp_enqueue_script('masonry', plugins_url('/js/masonry.pkgd.min.js', __FILE__), array('jquery'), false, false);
}

if (get_option('flowgallery_use_fancybox', "1") == 1)
{
	wp_enqueue_script('fancybox', plugins_url('/fancybox/jquery.fancybox.pack.js', __FILE__), array('jquery'), false, false);
	wp_register_style('fancybox', plugins_url('/fancybox/jquery.fancybox.css', __FILE__), false, '1.0.0', 'all');
	wp_enqueue_style( 'fancybox' );
}


// Add Shortcode
function flowgallery_embed_shortcode( $atts, $content = null ) {

	$picWidth = $atts['picwidth'];
	$sortparam = $atts['sort'];

	// attempt to get the directory where Wordpress is installed, which can be either / oder a directory like /blog
	$siteurl = site_url();
	$servername = $_SERVER['HTTP_HOST'];
	$pathToWp = substr($siteurl, strpos($siteurl, $servername)+strlen($servername));

	if ($handle = opendir(ABSPATH.$content)) 
	{		
		$gallery = "<div class='photogrid' style='margin-top: 15px;'>";
		$pics = array();
		while (false !== ($file = readdir($handle))) {
			// check if jp(e)g file and add if yes
			if (preg_match("/(?i)\.(jpg|jpeg)$/i", $file)) {
				$pics[] = "$content/$file";
			}
		}
		
		if ($sortparam) {
			if ($sortparam == "name_asc") sort($pics);
			if ($sortparam == "name_desc") rsort($pics);
			if ($sortparam == "newest") $pics = array_reverse($pics);
		}
		else {
			if (get_option('flowgallery_sorting') == "file_a") sort($pics);
			if (get_option('flowgallery_sorting') == "file_d") rsort($pics);
			if (get_option('flowgallery_sorting') == "newest") $pics = array_reverse($pics);
		}
		
		foreach ($pics as $pic) 
		{
			if (is_file(ABSPATH.$pic)) 
			{	
				$picSize = getimagesize(ABSPATH.$pic);
				$ratio = $picSize[0]/$picSize[1];
								
				$gallery .= "<div class='item ".(get_option('flowgallery_dropshadow','1') == 1 ? " shaded" : "")."' style='width:".$picWidth."px; height:".(get_option('flowgallery_square') == 1 ? $picWidth : floor($picWidth/$ratio))."px'><a href='".$pathToWp."/".$pic."' class='fancybox' rel='fancybox'> ";
				$gallery .= "<img alt='".$pic."' src='".plugins_url("/thumbnail.php", __FILE__)."?pic=".$pathToWp."/".$pic."&PicWidth=".$picWidth.(get_option('flowgallery_resample') == 1 ? "&resize=resample" : "").(get_option('flowgallery_square') == 1 ? "&square=true" : "")."' width='".$picWidth."' height='".(get_option('flowgallery_square') == 1 ? $picWidth : floor($picWidth/$ratio))."'> ";
				$gallery .= "</a>";
				$gallery .= "</div>\n";
			}
		}
		closedir($handle);
		$gallery .= "</div>";
		
		$gallery .= "<style>
			.item { margin-bottom: ".intval(get_option('flowgallery_padding','10'))."px; margin-right: ".intval(get_option('flowgallery_padding','10'))."px; }
			.shaded {-webkit-box-shadow:2px 2px 6px #000000; -moz-box-shadow:2px 2px 6px #000000; box-shadow:2px 2px 6px #000000;}
		</style>
		";	
	}
	
	return $gallery; 
}
add_shortcode( 'flowgallery', 'flowgallery_embed_shortcode' );
?>
